
@inproceedings{andre2013,
  title = {Supporting Adaptable Granularity of Changes for Massive-Scale Collaborative Editing},
  booktitle = {Proceedings of the 9th {{IEEE International Conference}} on {{Collaborative Computing}}: {{Networking}}, {{Applications}} and {{Worksharing}}},
  author = {Andr{\'e}, Luc and Martin, St{\'e}phane and Oster, G{\'e}rald and {Claudia-Lavinia Ignat}},
  year = {2013},
  month = nov,
  series = {{{CollaborateCom}} 2013},
  pages = {50--59},
  publisher = {{ICST}},
  address = {{Austin, Texas, USA}},
  doi = {10.4108/icst.collaboratecom.2013.254123},
  abstract = {Since the Web 2.0 era, the Internet is a huge content editing place in which users contribute to the content they browse. Users do not just edit the content but they collaborate on this content. Such shared content can be edited by thousands of people. However, current consistency maintenance algorithms seem not to be adapted to massive collaborative updating. Shared data is usually fragmented into smaller atomic elements that can only be added or removed. Coarse-grained data leads to the possibility of conflicting updates while fine-grained data requires more metadata. In this paper we offer a solution for handling an adaptable granularity for shared data that overcomes the limitations of fixed-grained data approaches. Our approach defines data at a coarse granularity when it is created and refines its granularity only for facing possible conflicting updates on this data. We exhibit three implementations of our algorithm and compare their performances with other algorithms in various scenarios.},
  keywords = {2013,conference,papoc22}
}

@article{balegas2018,
  title = {{{IPA}}: Invariant-Preserving Applications for Weakly Consistent Replicated Databases},
  shorttitle = {{{IPA}}},
  author = {Balegas, Valter and Duarte, S{\'e}rgio and Ferreira, Carla and Rodrigues, Rodrigo and Pregui{\c c}a, Nuno},
  year = {2018},
  month = dec,
  journal = {Proceedings of the VLDB Endowment},
  volume = {12},
  number = {4},
  pages = {404--418},
  issn = {2150-8097},
  doi = {10.14778/3297753.3297760},
  abstract = {It is common to use weakly consistent replication to achieve high availability and low latency at a global scale. In this setting, concurrent updates may lead to states where application invariants do not hold. Some systems coordinate the execution of (conflicting) operations to avoid invariant violations, leading to high latency and reduced availability for those operations. This problem is worsened by the difficulty in identifying precisely which operations conflict. In this paper we propose a novel approach to preserve application invariants without coordinating the execution of operations. The approach consists of modifying operations in a way that application invariants are maintained in the presence of concurrent updates. When no conflicting updates occur, the modified operations present their original semantics. Otherwise, we use sensible and deterministic conflict resolution policies that preserve the invariants of the application. To implement this approach, we developed a static analysis, IPA, that identifies conflicting operations and proposes the necessary modifications to operations. Our analysis shows that IPA can avoid invariant violations in many applications, including typical database applications. Our evaluation reveals that the offline static analysis runs fast enough for being used with large applications. The overhead introduced in the modified operations is low and it leads to lower latency and higher throughput when compared with other approaches that enforce invariants.},
  keywords = {papoc22}
}

@article{cherif2014,
  title = {Practical Access Control Management for Distributed Collaborative Editors},
  author = {Cherif, Asma and Imine, Abdessamad and Rusinowitch, Micha{\"e}l},
  year = {2014},
  month = dec,
  journal = {Pervasive and Mobile Computing},
  series = {Special {{Issue}} on {{Information Management}} in {{Mobile Applications}}},
  volume = {15},
  pages = {62--86},
  issn = {1574-1192},
  doi = {10.1016/j.pmcj.2013.09.004},
  abstract = {The project summarized in this article aims at developing techniques to support access control in Real-Time Distributed Collaborative Editors (RCE). The ever-increasing role of RCE in academic, industry and society comforts the expansion of data sharing and raises growing concerns about controlling access to this data. Indeed, RCE allow for a human\textendash computer\textendash human interaction in a decentralized fashion. Thus, access control for RCE requires a careful design since they need dynamic access changes and low latency access to shared document while maintaining its consistency. In this article, we propose a flexible access control model where the shared document and its authorization policy are replicated in the local memory of each user. To deal with latency and dynamic access changes, we use an optimistic access control technique in such a way that enforcement of authorizations is retroactive. Our model is generic enough to be deployed on the top of the most of existing logging-based collaborative systems. Indeed, it does not entail overheads and it does not affect the convergence of the shared document. We show that naive coordination between updates of both copies can create security holes on the shared document, by permitting illegal modifications or rejecting legal modifications and present our solutions to avoid these problems. Finally, we present a prototype for managing authorizations in collaborative editing work in a decentralized fashion. Thus our model may be deployed easily on mobile devices over P2P networks.},
  langid = {english},
  keywords = {access control,Authorization and access control,Collaborative editing systems,Mobile device applications,papoc22,Secure data management}
}

@inproceedings{corbett2012,
  title = {Spanner: {{Google}}'s {{Globally-Distributed Database}}},
  shorttitle = {Spanner},
  booktitle = {{{OSDI}}},
  author = {Corbett, James C. and Dean, Jeffrey and Epstein, Michael and Fikes, Andrew and Frost, Christopher and Furman, J. J. and Ghemawat, Sanjay and Gubarev, Andrey and Heiser, Christopher and Hochschild, Peter and Hsieh, Wilson and Kanthak, Sebastian and Kogan, Eugene and Li, Hongyi and Lloyd, Alexander and Melnik, Sergey and Mwaura, David and Nagle, David and Quinlan, Sean and Rao, Rajesh and Rolig, Lindsay and Woodford, Dale and Saito, Yasushi and Taylor, Christopher and Szymaniak, Michal and Wang, Ruth},
  year = {2012},
  month = oct,
  volume = {31},
  pages = {261--264},
  publisher = {{USENIX Association}},
  address = {{Hollywood, CA}},
  doi = {10.5555/2387880.2387905},
  abstract = {Spanner is Google's scalable, multiversion, globally distributed, and synchronously replicated database. It is the first system to distribute data at global scale and support externally-consistent distributed transactions. This article describes how Spanner is structured, its feature set, the rationale underlying various design decisions, and a novel time API that exposes clock uncertainty. This API and its implementation are critical to supporting external consistency and a variety of powerful features: nonblocking reads in the past, lock-free snapshot transactions, and atomic schema changes, across all of Spanner.},
  isbn = {978-1-931971-96-6},
  keywords = {papoc22}
}

@inproceedings{nicolas2017,
  title = {{{MUTE}}: A Peer-to-Peer Web-Based Real-Time Collaborative Editor},
  booktitle = {Proceedings of the 15th {{European Conference}} on {{Computer-Supported Cooperative Work}}},
  author = {Nicolas, Matthieu and Elvinger, Victorien and Oster, G{\'e}rald and Ignat, Claudia-Lavinia and Charoy, Fran{\c c}ois},
  year = {2017},
  month = aug,
  series = {{{ECSCW}} 2017},
  volume = {1},
  pages = {1--4},
  publisher = {{EUSSET}},
  address = {{Sheffield, United Kingdom}},
  doi = {10.18420/ecscw2017_p5},
  keywords = {2017,papoc22,posterdemo}
}

@incollection{nicolas2020,
  title = {Efficient Renaming in Sequence {{CRDTs}}},
  booktitle = {Proceedings of the 7th {{Workshop}} on {{Principles}} and {{Practice}} of {{Consistency}} for {{Distributed Data}}},
  author = {Nicolas, Matthieu and Oster, G{\'e}rald and Perrin, Olivier},
  year = {2020},
  month = apr,
  series = {{{PaPoC}} '20},
  number = {9},
  pages = {1--8},
  publisher = {{Association for Computing Machinery}},
  address = {{New York, NY, USA}},
  abstract = {To achieve high availability, large-scale distributed systems have to replicate data and to minimise coordination between nodes. Literature and industry increasingly adopt Conflictfree Replicated Data Types (CRDTs) to design such systems. CRDTs are data types which behave as traditional ones, e.g. the Set or the Sequence. However, unlike traditional data types, they are designed to natively support concurrent modifications. To this end, they embed in their specification a conflict-resolution mechanism. To resolve conflicts in a deterministic manner, CRDTs usually attach identifiers to elements stored in the data structure. Identifiers have to comply with several constraints, such as uniqueness or belonging to a dense order. These constraints may hinder the identifiers' size from being bounded. As the system progresses, identifiers tend to grow. This inflation deepens the overhead of the CRDT over time, leading to performance issues. To address this issue, we propose a new CRDT for Sequence which embeds a renaming mechanism. It enables nodes to reassign shorter identifiers to elements in an uncoordinated manner. Experimental results demonstrate that this mechanism decreases the overhead of the replicated data structure and eventually limits it.},
  isbn = {978-1-4503-7524-5},
  keywords = {CRDTs,eventual consistency,memory-wise optimisation,papoc22,performance,real-time collaborative editing}
}

@inproceedings{pang2019,
  title = {Zanzibar: {{Google}}'s {{Consistent}}, {{Global Authorization System}}},
  shorttitle = {Zanzibar},
  booktitle = {Proceedings of the 2019 {{USENIX Conference}} on {{Usenix Annual Technical Conference}}},
  author = {Pang, Ruoming and Caceres, Ramon and Burrows, Mike and Chen, Zhifeng and Dave, Pratik and Germer, Nathan and Golynski, Alexander and Graney, Kevin and Kang, Nina and Kissner, Lea and Korn, Jeffrey L. and Parmar, Abhishek and Richards, Christopher D. and Wang, Mengzhi},
  year = {2019},
  series = {{{USENIX ATC}} '19},
  pages = {33--46},
  publisher = {{USENIX Association}},
  address = {{Renton, WA}},
  doi = {10.5555/3358807.3358811},
  abstract = {Determining whether online users are authorized to access digital objects is central to preserving privacy. This paper presents the design, implementation, and deployment of Zanzibar, a global system for storing and evaluating access control lists. Zanzibar provides a uniform data model and configuration language for expressing a wide range of access control policies from hundreds of client services at Google, including Calendar, Cloud, Drive, Maps, Photos, and YouTube. Its authorization decisions respect causal ordering of user actions and thus provide external consistency amid changes to access control lists and object contents. Zanzibar scales to trillions of access control lists and millions of authorization requests per second to support services used by billions of people. It has maintained 95th-percentile latency of less than 10 milliseconds and availability of greater than 99.999\% over 3 years of production use.},
  isbn = {978-1-939133-03-8},
  keywords = {papoc22}
}

@article{sandhu1996,
  title = {Role-Based Access Control Models},
  author = {Sandhu, Ravi S. and Coyne, Edward J. and Feinstein, Hal L. and Youman, Charles E.},
  year = {1996},
  month = feb,
  journal = {Computer},
  volume = {29},
  number = {2},
  pages = {38--47},
  issn = {0018-9162},
  doi = {10.1109/2.485845},
  abstract = {Security administration of large systems is complex, but it can be simplified by a role-based access control approach. This article explains why RBAC is receiving renewed attention as a method of security administration and review, describes a framework of four reference models developed to better understand RBAC and categorizes different implementations, and discusses the use of RBAC to manage itself.},
  keywords = {Access control,Authorization,Data security,Government,NIST,papoc22,Permission,Privacy,Resource management,Software systems,Telephony}
}

@phdthesis{shapiro2011,
  type = {Report},
  title = {A Comprehensive Study of {{Convergent}} and {{Commutative Replicated Data Types}}},
  author = {Shapiro, Marc and Pregui{\c c}a, Nuno and Baquero, Carlos and Zawirski, Marek},
  year = {2011},
  month = jan,
  pages = {50},
  abstract = {Eventual consistency aims to ensure that replicas of some mutable shared object converge without foreground synchronisation. Previous approaches to eventual consistency are ad-hoc and error-prone. We study a principled approach: to base the design of shared data types on some simple formal conditions that are sufficient to guarantee eventual consistency. We call these types Convergent or Commutative Replicated Data Types (CRDTs). This paper formalises asynchronous object replication, either state based or operation based, and provides a sufficient condition appropriate for each case. It describes several useful CRDTs, including container data types supporting both \textbackslash add and \textbackslash remove operations with clean semantics, and more complex types such as graphs, montonic DAGs, and sequences. It discusses some properties needed to implement non-trivial CRDTs.},
  langid = {english},
  school = { \textendash{} Centre Paris-Rocquencourt ; INRIA},
  keywords = {papoc22}
}

@inproceedings{weber2016,
  ids = {DBLP:conf/stm/0001BP16},
  title = {Access {{Control}} for {{Weakly Consistent Replicated Information Systems}}},
  booktitle = {Proceedings of {{International Workshop}} on {{Security}} and {{Trust Management}}},
  author = {Weber, Mathias and Bieniusa, Annette and {Poetzsch-Heffter}, Arnd},
  editor = {Barthe, Gilles and Markatos, Evangelos and Samarati, Pierangela},
  year = {2016},
  month = sep,
  series = {{{STM}}~2016},
  pages = {82--97},
  publisher = {{Springer International Publishing}},
  address = {{Cham}},
  doi = {10.1007/978-3-319-46598-2_6},
  abstract = {Access control is an important aspect of information systems. It manages and enforces the rules that govern the access of users and applications to the data. In general, both data objects and access rules are subject to change over time, e.g., one might withdraw the right of a user to access a certain data object.In this paper, we present a new access control model for weakly consistent replicated information systems. Such systems are engineered to be partition-tolerant and higher available than strongly consistent systems \textendash{} an important aspect in a networked world with mobile devices. In particular, they allow concurrent updates to different replicas and do not enforce serializability of operations. However, this relaxation of consistency threatens access control. If we withdraw the right of a user to access data object o at one replica and then modify o, the user should not be able to see this modification by accessing o on a second replica (information leakage).Our access control model targets eventually consistent data stores. It avoids information leakage and unauthorized modifications. Furthermore, it guarantees that modifications to the access rules initiated on different replicas eventually converge. Our model allows in particular to implement access-matrix based models such as the read-write-own model employed in file systems. In this paper, we define the model in an abstract way, explain its correctness properties, and describe how it can be efficiently implemented in state-of-the-art weakly consistent data stores.},
  bibsource = {dblp computer science bibliography, https://dblp.org},
  biburl = {https://dblp.org/rec/conf/stm/0001BP16.bib},
  isbn = {978-3-319-46598-2},
  langid = {english},
  keywords = {access control,Access Control System,Application-level Operations,Consistent Data Storage,papoc22,Precise Execution,Relative Protection},
  timestamp = {Sat, 19 Oct 2019 20:20:00 +0200}
}

@inproceedings{yanakieva2021,
  title = {Access {{Control Conflict Resolution}} in {{Distributed File Systems}} Using {{CRDTs}}},
  booktitle = {Proceedings of the 8th {{Workshop}} on {{Principles}} and {{Practice}} of {{Consistency}} for {{Distributed Data}}},
  author = {Yanakieva, Elena and Youssef, Michael and Rezae, Ahmad Hussein and Bieniusa, Annette},
  year = {2021},
  month = apr,
  series = {{{PaPoC}} '21},
  pages = {1--3},
  publisher = {{Association for Computing Machinery}},
  address = {{New York, NY, USA}},
  doi = {10.1145/3447865.3457970},
  abstract = {Distributed file systems have become an essential service for sharing data among users. An important aspect of a file system is its ability to keep its contents secure from unauthorized access. To investigate the interplay of security and consistency in distributed file systems, we formalize the three properties related to data security, namely confidentiality, integrity and accessibility. Based on these properties, we provide an impossibility result that indicates that these properties cannot be achieved together in a highly-available partition-tolerant setting. We further discuss a CRDT-based model, implementing the traditional POSIX access control policy, that guarantees confidentiality and integrity while precluding accessibility only in rare situations. Our conclusion is that the POSIX policies are not suitable in a distributed system setting, but that a more fine-grained model is required to obtain the security semantics that reflect the users' intention.},
  isbn = {978-1-4503-8338-7},
  keywords = {access control,conflict-free replicated data type,distributed file system,papoc22,POSIX}
}

@inproceedings{yanakieva2021a,
  title = {On the {{Impossibility}} of {{Confidentiality}}, {{Integrity}} and {{Accessibility}} in~{{Highly-Available File Systems}}},
  booktitle = {Proceedings of the {{International Conference}} on {{Networked Systems}}},
  author = {Yanakieva, Elena and Youssef, Michael and Rezae, Ahmad Hussein and Bieniusa, Annette},
  editor = {Echihabi, Karima and Meyer, Roland},
  year = {2021},
  month = dec,
  series = {{{NETYS}} 2021},
  pages = {3--18},
  publisher = {{Springer International Publishing}},
  address = {{Cham}},
  doi = {10.1007/978-3-030-91014-3_1},
  abstract = {Distributed file systems are at the core of many services for sharing data among users. To keep the file contents secure from unauthorized access, such systems make use of custom access control policies similar to the traditional POSIX policies.In our work, we want to investigate the interdependence of secure access and high-availability. To this end, we formalize the three properties related to data security, namely confidentiality, integrity and accessibility (CIA). We proof the CIA impossibility showing that these properties cannot be achieved together in a highly-available partition-tolerant setting. We further discuss a CRDT-based model that implements an access control policy similar to the POSIX one and that guarantees confidentiality and integrity while precluding accessibility only in rare situations.},
  isbn = {978-3-030-91014-3},
  langid = {english},
  keywords = {Access control,Conflict-free replicated data type,CRDT,Distributed file system,papoc22,POSIX}
}

@inproceedings{yu2015,
  title = {A {{CRDT}} Supporting Selective Undo for Collaborative Text Editing},
  booktitle = {Proceedings of the 15th {{IFIP International Conference}} on {{Distributed Applications}} and {{Interoperable Systems}}},
  author = {Yu, Weihai and Andr{\'e}, Luc and Ignat, Claudia-Lavinia},
  editor = {Bessani, Alysson and Bouchenak, Sara},
  year = {2015},
  month = jun,
  series = {{{DAIS}} 2015},
  pages = {193--206},
  publisher = {{Springer International Publishing}},
  address = {{Grenoble, France}},
  doi = {10.1007/978-3-319-19129-4_16},
  hal_id = {hal-01246212},
  hal_version = {v1},
  pdf = {https://hal.inria.fr/hal-01246212/file/paper\textsubscript{D}AIS2015.pdf},
  keywords = {collaborative editing,CRDT,papoc22,undo}
}

@inproceedings{yu2019,
  title = {A {{Generic Undo Support}} for {{State-Based CRDTs}}},
  booktitle = {Proceedings of the 23rd {{International Conference}} on {{Principles}} of {{Distributed Systems}}},
  author = {Yu, Weihai and Elvinger, Victorien and Ignat, Claudia-Lavinia},
  year = {2019},
  month = dec,
  series = {{{OPODIS}} 2019},
  doi = {10.4230/LIPIcs.OPODIS.2019.14},
  abstract = {CRDTs (Conflict-free Replicated Data Types) have properties desirable for large-scale distributed systems with variable network latency or transient partitions. With CRDT, data are always available for local updates and data states converge when the replicas have incorporated the same updates. Undo is useful for correcting human mistakes and for restoring system-wide invariant violated due to long delays or network partitions. There is currently no generally applicable undo support for CRDTs. There are at least two reasons for this. First, there is currently no abstraction that we can practically use to capture the relations between undo and normal operations with respect to concurrency and causality. Second, using inverse operations as the existing partial solutions, the CRDT designer has to hard-code certain rules and design a new CRDT for almost every operation that needs undo support. In this paper, we present an approach to generic support of undo for CRDTs. The approach consists of two major parts. We first work out an abstraction that captures the semantics of concurrent undo and redo operations through equivalence classes. The abstraction is a natural extension of undo and redo in sequential applications and is straightforward to implement in practice. By using this abstraction, we then device a mechanism to augment existing CRDTs. The mechanism provides an "out of the box" support for undo without the involvement of the CRDT designers. We also present a practical application of the approach in collaborative editing.},
  langid = {english},
  keywords = {papoc22}
}


